from dsmapi2 import *
handle = DsmApiInitialize()
#DsmApiOpen(handle, "serial:///dev/ttyUSB0", 0)
DsmApiOpen(handle, "tcp://localhost:8442", 0)
#DsmApiOpen(handle, "tcp://192.168.2.124:8442", 0)
#DsmApiOpen(handle, "tcp://192.168.2.145:8442", 0)
#DsmApiOpen(handle, "tcp://10.0.0.91:8442", 0)

(ret, link) = DsmApiGetLinkState(handle)
print "link state: %r" % link
DsmApiGetBusMembers(handle, 63)
DsmApiGetOwnDSUID(handle)

dsuid = range(17)

def DeviceStatisticsCallback(sourceId, destinationId, DeviceIndex, Offset, Value):
	print "source: " + ", ".join(map(str, sourceId)) + ": Device: %d, Offset %d, Value 0x%x" %(DeviceIndex, Offset, Value)

DsmApiRegisterPyCallback(handle, DS485_CONTAINER_EVENT, EVENT_DEVICE_STATISTICS, 0, DeviceStatisticsCallback)

def DeviceParameterCallback(sourceId, destinationId, DeviceIndex, Offset, Value):
	print "source: " + ", ".join(map(str, sourceId)) + ": Device: %d, Offset %d, Value 0x%x" %(DeviceIndex, Offset, Value)

DsmApiRegisterPyCallback(handle, DS485_CONTAINER_EVENT, EVENT_DEVICE_CONFIG, 0, DeviceParameterCallback)

def EnergyCallback(sourceId, destinationId, Umax, Umin, I14max, I14min, I180max, I180min, PActiveLow, PActiveHigh):
	print "source: " + ", ".join(map(str, sourceId)) + ": PActiveLow: %d" %(PActiveLow)

DsmApiRegisterPyCallback(handle, DS485_CONTAINER_RESPONSE, CIRCUIT_ENERGY_METER_VALUE, CIRCUIT_ENERGY_METER_VALUE_CALIBRATION, EnergyCallback)

DeviceStatisticsRequest_get(handle, dsuid, 65, 0xff);
DeviceConfig_get(handle, dsuid, 66, 128, 128+41)

dsuid = range(17)
ZoneCount(handle, dsuid)
(result, GlobalZoneId, LocalZoneId, NumberOfGroups, Name) = ZoneInfo_by_index(handle, dsuid, 0)
(result, DeviceCount) = ZoneDeviceCount_only_active(handle, dsuid, GlobalZoneId)

dSMInfo(handle, dsuid)
name = "Test"
dSMProperties_set_name(handle, dsuid, name)
dSMProperties_set_apartment_id(handle, dsuid, 16)
dSMInfo(handle, dsuid)

hw_version = 0x12345678
dSMConfig_set_dSM_config(handle, dsuid, dsuid, hw_version)

dSMReboot(handle, dsuid)

dSMFactoryReset(handle, dsuid, 0xcafe)
dSMDebugMode_restart_registration(handle, dsuid)
dSMReboot(handle, dsuid)

def dSMConfigCallback(sourceId, destinationId, length, data):
	print data
	dsp_config_struct = "<HHHHHHBBBBBBHHHBBBBIIHHHHHH"
	print unpack(dsp_config_struct, config_str)

DsmApiRegisterPyCallback(handle, DS485_CONTAINER_RESPONSE, DSM_CONFIG, DSM_CONFIG_GET_DSP_CONFIG, dSMConfigCallback)


(result, length, data) = dSMConfig_get_DSP_config(handle, dsuid)
config_str = ""
for i in data[0:length]:
	config_str += chr(i)

dsp_config_struct = "<HHHHHHBBBBBBHHHBBBBIIHHHHHH"
unpack(dsp_config_struct, config_str)

from time import strftime, localtime, sleep
for i in range(10000):
	sleep(4)
	result = CircuitEnergyMeterValue_calibration(handle, dsuid)
	if result[0] != 0:
		print strftime("%a, %d %b %Y %H:%M:%S +0000", localtime()) + ": " + str(result)

	
CircuitEnergyMeterValue_get(handle, dsuid)

dSMStatistics_get_dS485(handle, dsuid)
dSMStatistics_get_upstream(handle, dsuid)

ImageMaintenance_start_update(handle, dsuid)
ImageMaintenance_remove_image(handle, dsuid)

dSMDebugMode_stop_select_b(handle, dsuid)

DsmApiClose(handle)
DsmApiCleanup(handle)

import time
for i in range(50):
	ZoneGroupActionRequest_action_call_scene(handle, dsuid, 0xffff, 1, 5)
	time.sleep(5)
	ZoneGroupActionRequest_action_call_scene(handle, dsuid, 0xffff, 1, 0)
	time.sleep(5)

from dsmapi2 import *
handle = DsmApiInitialize()
DsmApiOpen(handle, "tcp://localhost:8442", 0)

from DSP_config import *
(result, mydsuid) = DsmApiGetOwnDSUID(handle)
if result != 0:
	print "No connection"

result = DsmApiGetBusMembers(handle, 63)
while (result[0] < 2):
    result = DsmApiGetBusMembers(handle, 63)

dsm_list = list()
result = DsmApiGetBusMembers(handle, 63)
if isinstance(result, tuple):
	if result[0] < 0:
		print "No connection"
	else:
		length = result[0]
		for dsm in result[1:]:
			if dsm != mydsuid:
				dsuid = list()
				for i in dsm:
					dsuid.append(i)
				dsm_list.append(dsuid)

from time import sleep
for dsm in dsm_list:
	ZoneCount(handle, dsm)
	sleep(1)

while True:
	for dsm in dsm_list:
		print "=============================================================="
		#config = DSP_config(handle, dsm)
		#config.readConfig()
		#config.printConfig()
		
		(result, HWVersion, SWVersion, ApiVersion, DSID, Named) = dSMInfo(handle, dsm)
		if result >= 0:
			print "dSID: " + " ".join(map(lambda x: "%02x" % x, DSID))
		else:
			print "Error!"

for i in range(1000):
	for dsm in dsm_list:
		(result, count) = ZoneCount(handle, dsm)
		if result < 0:
			print "Error: ZoneCount"
		(result, GlobalZoneId, LocalZoneId, NumberOfGroups, Name) = ZoneInfo_by_index(handle, dsm, 0)
		if result < 0:
			print "Error: ZoneInfo_by_index"
			continue
		(result, DeviceCount) = ZoneDeviceCount_only_active(handle, dsm, GlobalZoneId)
		if result < 0:
			print "Error: ZoneDeviceCount_only_active"

for dsm in dsm_list:
	dSMStatistics_get_dS485(handle, dsm)

for dsm in dsm_list:
	ImageMaintenance_check_image(handle, dsm)

for dsm in dsm_list:
	ImageMaintenance_start_update(handle, dsm)

from time import strftime, localtime
last = 0
while True:
	result = DsmApiGetBusMembers(handle, 63)
	if result[0] != last:
		print strftime("%a, %d %b %Y %H:%M:%S +0000", localtime()) + ": " + str(result)
		last = result[0]

from dsmapi2 import *
handle = DsmApiInitialize()
DsmApiOpen(handle, "tcp://localhost:8442", 0)
def EnergyCallback(sourceId, destinationId, Umax, Umin, I14max, I14min, I180max, I180min, PActiveLow, PActiveHigh):
	print "source: " + ", ".join(map(str, sourceId)) + ": PActiveLow: %d" %(PActiveLow)

DsmApiRegisterPyCallback(handle, DS485_CONTAINER_RESPONSE, CIRCUIT_ENERGY_METER_VALUE, CIRCUIT_ENERGY_METER_VALUE_GET, EnergyCallback)
CircuitEnergyMeterValue_get(handle, [0xff]*17)
CircuitEnergyMeterValue_calibration(handle, [0xff]*17)

dsuid = range(17)
ZoneCount(handle, dsuid)


from dsmapi2 import *
handle = DsmApiInitialize()
DsmApiOpen(handle, "tcp://localhost:8442", 0)
def EventCommunicationLog_upstream_short_callback(error, sourceId, destinationId, DeviceId, CircuitId, Resend, MessageKind, Key, Click):
	print "US: DeviceId: %d, Circuit: %d, Key: %d, Click: %d" %(DeviceId, CircuitId, Key, Click)

DsmApiRegisterPyCallback(handle, DS485_CONTAINER_EVENT, EVENT_COMMUNICATION_LOG, EVENT_COMMUNICATION_LOG_UPSTREAM_SHORT, EventCommunicationLog_upstream_short_callback)
def EventCommunicationLog_upstream_long_callback(error, sourceId, destinationId, DeviceId, CircuitId, Mainqualifier, Subqualifier, Data):
	print "UL: DeviceId: %d, Circuit: %d, Mainqualifier: %d, Subqualifier: %d, Data: %d" %(DeviceId, CircuitId, Mainqualifier, Subqualifier, Data)

DsmApiRegisterPyCallback(handle, DS485_CONTAINER_EVENT, EVENT_COMMUNICATION_LOG, EVENT_COMMUNICATION_LOG_UPSTREAM_LONG, EventCommunicationLog_upstream_long_callback)

def EventCommunicationLog_downstream_short_callback(error, sourceId, destinationId, Cmd):
	print "DS: Cmd: %d" %(Cmd)

DsmApiRegisterPyCallback(handle, DS485_CONTAINER_EVENT, EVENT_COMMUNICATION_LOG, EVENT_COMMUNICATION_LOG_DOWNSTREAM_SHORT, EventCommunicationLog_downstream_short_callback)
def EventCommunicationLog_downstream_long_no_callback(error, sourceId, destinationId, Cmd):
	print "DL: Cmd: %d" %(Cmd)

DsmApiRegisterPyCallback(handle, DS485_CONTAINER_EVENT, EVENT_COMMUNICATION_LOG, EVENT_COMMUNICATION_LOG_DOWNSTREAM_LONG_NO_PARAMETER, EventCommunicationLog_downstream_long_no_callback)
def EventCommunicationLog_downstream_long_callback(error, sourceId, destinationId, Cmd, Data):
	print "DL: Cmd: %d, Data: %d" %(Cmd, Data)

DsmApiRegisterPyCallback(handle, DS485_CONTAINER_EVENT, EVENT_COMMUNICATION_LOG, EVENT_COMMUNICATION_LOG_DOWNSTREAM_LONG_8BIT_PARAMETER, EventCommunicationLog_downstream_long_callback)
DsmApiRegisterPyCallback(handle, DS485_CONTAINER_EVENT, EVENT_COMMUNICATION_LOG, EVENT_COMMUNICATION_LOG_DOWNSTREAM_LONG_16BIT_PARAMETER, EventCommunicationLog_downstream_long_callback)

def BusChange_Callback(dsuid, flag):
	if flag == 0:
		print "Device", ":".join(map(str, dsuid)), "joined"
	else:
		print "Device", ":".join(map(str, dsuid)), "left"

DsmApiRegisterPyBusChangeCallback(handle, BusChange_Callback)


dsuid = range(17)
dSMDebugMode_set_communication_log_state(handle, dsuid, 3)


from dsmapi2 import *
import sys
sys.path.append('/home/christian/dsmduo-tools')
handle = DsmApiInitialize()
DsmApiOpen(handle, "tcp://localhost:8442", 0)

dsuid = range(17)

from DSP_config import *
config = DSP_config(handle, dsuid)
config.readConfig()
config.power_calibration_low
CircuitEnergyMeterValue_calibration(handle, dsuid)
config.power_calibration_low *= 100
config.writeConfig()
dSMDebugMode_restart_dsp(handle, dsuid)
CircuitEnergyMeterValue_calibration(handle, dsuid)

from dsmapi2 import *
import sys
sys.path.append('/home/christian/dsmduo-tools')
handle = DsmApiInitialize()
DsmApiOpen(handle, "tcp://localhost:8442", 0)

dsuid = range(17)
dSMDebugMode_read_flash(handle, dsuid, 1000)


from dsmapi2 import *
handle = DsmApiInitialize()
DsmApiOpen(handle, "tcp://localhost:8442", 0)

def EventTestTransmissionQuality_callback(error, sourceId, destinationId, DeviceId, DownstreamData, UpstreamData):
	print "TEST_B: DeviceId: %d, Downstream: %d, Upstream: %d" %(DeviceId, DownstreamData, UpstreamData)

DsmApiRegisterPyCallback(handle, DS485_CONTAINER_EVENT, EVENT_TEST_TRANSMISSION_QUALITY, 0, EventTestTransmissionQuality_callback)


dsuid = range(17)
ZoneDeviceCount_only_active(handle, dsuid, 0)
result = DeviceInfo_by_index_only_active(handle, dsuid, 0, 0)
result[0]
TestTransmissionQuality_get(handle, dsuid, result[1])

from dsmapi2 import *
handle = DsmApiInitialize()
DsmApiOpen(handle, "tcp://localhost:8442", 0)

dsuid = range(17)
dSMProperties_get_apartment_id(handle, dsuid)
dSMProperties_get_temperature_limits(handle, dsuid)


from dsmapi2 import *
handle = DsmApiInitialize()
DsmApiOpen(handle, "tcp://localhost:8442", 0)

dsuid = range(17)
CircuitRemoveDevice(handle, dsuid, 64)
